//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39AD40BF02D0.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39AD40BF02D0.cm

//## begin module%39AD40BF02D0.cp preserve=no
//## end module%39AD40BF02D0.cp

//## Module: SfBackground%39AD40BF02D0; Package specification
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Data/BackCorr/SfBackground.h

#ifndef SFBACKGROUND_H
#define SFBACKGROUND_H 1

//## begin module%39AD40BF02D0.additionalIncludes preserve=no
//## end module%39AD40BF02D0.additionalIncludes

//## begin module%39AD40BF02D0.includes preserve=yes
//## end module%39AD40BF02D0.includes

// Background
#include <XSModel/Data/BackCorr/Background.h>
// SfIO
#include <XSModel/DataFactory/SfIO.h>
//## begin module%39AD40BF02D0.declarations preserve=no
//## end module%39AD40BF02D0.declarations

//## begin module%39AD40BF02D0.additionalDeclarations preserve=yes
//## end module%39AD40BF02D0.additionalDeclarations


//## begin SfBackCorr%39AD401601E5.preface preserve=yes
//## end SfBackCorr%39AD401601E5.preface

//## Class: SfBackCorr%39AD401601E5
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3AAD3CD5005D;DataSet { -> }

class SfBackCorr : public BackCorr, //## Inherits: <unnamed>%39AD402C021D
                   	public SfIO  //## Inherits: <unnamed>%39AD40820085
{
  //## begin SfBackCorr%39AD401601E5.initialDeclarations preserve=yes
  //## end SfBackCorr%39AD401601E5.initialDeclarations

  public:
    //## Constructors (generated)
      SfBackCorr();

      SfBackCorr(const SfBackCorr &right);

    //## Destructor (generated)
      virtual ~SfBackCorr();


    //## Other Operations (specified)
      //## Operation: fileFormat%39AD674A0083
      //	type() returns true if the input filename is of the
      //	format corresponding to the class.
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: clone%39DA0C8103A6
      virtual SfBackCorr* clone () const;

      //## Operation: read%3A2D39C401A3
      virtual size_t read (const string& fileName, bool readFlag = true);

      //## Operation: closeSourceFiles%3A3940A500F2
      void closeSourceFiles ();

      //## Operation: initialize%3D3C36660264
      virtual void initialize (DataSet* parentData, size_t row, const string& fileName, size_t backCorRow);

    // Additional Public Declarations
      //## begin SfBackCorr%39AD401601E5.public preserve=yes
      //## end SfBackCorr%39AD401601E5.public

  protected:

    //## Other Operations (specified)
      //## Operation: setDescription%3A01E2C70285
      virtual void setDescription (size_t spectrumNumber = 1);

      //## Operation: scaleArrays%3A01E2CC0080
      virtual void scaleArrays (bool correction = false);

      //## Operation: setArrays%3A2BC5CE01BD
      virtual void setArrays (size_t backgrndRow, bool ignoreStats = false);

    // Additional Protected Declarations
      //## begin SfBackCorr%39AD401601E5.protected preserve=yes
      //## end SfBackCorr%39AD401601E5.protected

  private:
    //## Assignment Operation (generated)
      SfBackCorr & operator=(const SfBackCorr &right);


    //## Other Operations (specified)
      //## Operation: copy%3A95835F019C
      virtual void copy (const BackCorr& right);

      //## Operation: Swap%3A95836B0077
      virtual void Swap (BackCorr& right);

    // Additional Private Declarations
      //## begin SfBackCorr%39AD401601E5.private preserve=yes
      //## end SfBackCorr%39AD401601E5.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin SfBackCorr%39AD401601E5.implementation preserve=yes
      //## end SfBackCorr%39AD401601E5.implementation

};

//## begin SfBackCorr%39AD401601E5.postscript preserve=yes
//## end SfBackCorr%39AD401601E5.postscript

//## begin SfBackground%39F8590802AB.preface preserve=yes
//## end SfBackground%39F8590802AB.preface

//## Class: SfBackground%39F8590802AB
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



typedef SfBackCorr SfBackground;

//## begin SfBackground%39F8590802AB.postscript preserve=yes
//## end SfBackground%39F8590802AB.postscript

//## begin SfCorrection%39F859BD03C7.preface preserve=yes
//## end SfCorrection%39F859BD03C7.preface

//## Class: SfCorrection%39F859BD03C7
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



typedef SfBackCorr SfCorrection;

//## begin SfCorrection%39F859BD03C7.postscript preserve=yes
//## end SfCorrection%39F859BD03C7.postscript

// Class SfBackCorr 

//## begin module%39AD40BF02D0.epilog preserve=yes
//## end module%39AD40BF02D0.epilog


#endif
